unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, ExtCtrls, math, Buttons;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Label1: TLabel;
    Edit2: TEdit;
    Label2: TLabel;
    Edit3: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Button1: TButton;
    ProgressBar1: TProgressBar;
    Timer1: TTimer;
    Memo1: TMemo;
    SpeedButton1: TSpeedButton;
    Panel1: TPanel;
    Label7: TLabel;
    Label8: TLabel;
    Image1: TImage;
    Memo2: TMemo;
    Button2: TButton;
    procedure Timer1Timer(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Play;
    function GGC:boolean;
    procedure Button2Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  startmoney,bid,playcount:integer;
  money:integer;

implementation

{$R *.dfm}

//,    
procedure TForm1.Timer1Timer(Sender: TObject); 
var n,i:cardinal;
begin
 Randomize; // ,     GGC   
 try
  n:=0;
  i:=0;
  while n<=StrToInt(edit1.Text) do
   begin
    i:=i+1;
    n:=n+n+StrToInt(Edit2.text);
   end;
  label6.Caption:=IntToStr(i-1);
 except
  label6.Caption:='?';
 end;
end;

//  
procedure TForm1.Button1Click(Sender: TObject);
begin
 try
  startmoney:=StrToInt(Edit1.text);
  bid:=StrToInt(Edit2.text);
  playcount:=StrToInt(Edit3.text);
  money:=startmoney;
  Progressbar1.Position:=0;
  Progressbar1.Max:=playcount;
  Progressbar1.Repaint;
  memo1.text:='?';
  memo1.Repaint;
  Application.ProcessMessages;
  Play;
 except
  memo1.text:='   .';
 end;
end;

// 50  50,   
function TForm1.GGC:boolean;
var x:byte;
begin
 Result:=false; //black
 x:=Random(2);
 if x=1 then Result:=true; //red
end;

// 
procedure TForm1.Play;
var clr,myclr:boolean; {black=0,red=1} nextbid,i,maxbid,bad,maxbad:integer;
begin
 bad:=0; // , 
 maxbad:=0; //   ( )
 maxbid:=0; //  ( )
 nextbid:=bid; // ,    
 myclr:=false; //  
 i:=0;
 while ((i<playcount) and ((money-bid)>0)) do //       
  begin
   i:=i+1; //  
   clr:=GGC; //   
   if clr=myclr then //,  
    begin
     money:=money+nextbid; // 
     nextbid:=bid; //    
     bad:=0; //   
     myclr:= not myclr; //   
    end else // 
    begin
     money:=money-nextbid; //  
     nextbid:=nextbid*2; // ,      ,
     if (nextbid)>money then nextbid:=bid; //    -   
     bad:=bad+1; //  
    end;
   if maxbad<bad then maxbad:=bad; //, :  
   if maxbid<nextbid then maxbid:=nextbid; //, :  
   Progressbar1.Position:=i;
   Progressbar1.Repaint;
   Application.ProcessMessages;
  end;
 memo1.Text:=':   '+IntToStr(money)+'.'+#13+#10+' : '+IntToStr(i)+'.'+#13+#10+':  '+IntToStr(maxbid)+','+#13+#10+' : '+IntToStr(maxbad)+'.';
 if money>startmoney then memo1.Font.Color:=clGreen else memo1.Font.Color:=clRed;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
 Panel1.Hide;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
 Panel1.Show;
 Panel1.Left:=-1;
end;

end.
